apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ greenlight_name }}
  name: {{ greenlight_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ greenlight_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ greenlight_name }}
  strategy:
{% if greenlight_db_type != 'postgres' %}
    type: Recreate
{% else %}
    type: RollingUpdate
{% endif %}
{% else %}
    name: {{ greenlight_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
{% if greenlight_db_type != 'postgres' %}
    type: Recreate
{% else %}
    type: Rolling
{% endif %}
{% endif %}
  template:
    metadata:
      labels:
        name: {{ greenlight_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ greenlight_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ greenlight_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: ALLOW_GREENLIGHT_ACCOUNTS
          value: "{{ 'tru' if (greenlight_local_accounts) else 'fals' }}e"
        - name: BIGBLUEBUTTON_ENDPOINT
          valueFrom:
            secretKeyRef:
              key: bbb-api-url
              name: {{ greenlight_name }}
        - name: BIGBLUEBUTTON_SECRET
          valueFrom:
            secretKeyRef:
              key: bbb-secret
              name: {{ greenlight_name }}
        - name: DB_ADAPTER
{% if greenlight_db_type == 'postgres' %}
          value: postgresql
        - name: DB_NAME
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ greenlight_pg_name }}
        - name: DB_HOST
          value: {{ greenlight_pg_name }}
        - name: DB_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ greenlight_pg_name }}
        - name: DB_PORT
          vaue: "5432"
        - name: DB_USERNAME
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ greenlight_pg_name }}
{% else %}
          value: sqlite3
        - name: DB_NAME
          value: db/production/greenlight.sqlite
{% endif %}
        - name: DEFAULT_REGISTRATION
          value: {{ greenlight_registration }}
        - name: ENABLE_SSL
          value: "true"
        - name: HELP_URL
          value: {{ greenlight_help_url }}
        - name: LDAP_AUTH
{% if do_ldap %}
          value: user
        - name: LDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: LDAP_BIND_DN
          value: cn=greenlight,ou=services,{{ ldap_directory_root }}
        - name: LDAP_FILTER
{% if do_fusion %}
          value: '(&(objectClass=gosaAccount)(!(pwdAccountLockedTime=*)))'
{% else %}
          value: '(&(objectClass={{ greenlight_ldap_user_objectclass }})(!(pwdAccountLockedTime=*)))'
{% endif %}
        - name: LDAP_METHOD
{% if ldaps_address | default(False) %}
          value: ssl
{% else %}
          value: plain
{% endif %}
        - name: LDAP_PASSWORD
          valueFrom:
            secretKeyRef:
              key: greenlight-password
              name: {{ ldap_secret_name }}
        - name: LDAP_PORT
{% if ldaps_address | default(False) %}
          value: "{{ ldaps_address | urlsplit('port') }}"
{% else %}
          value: "{{ ldap_address | urlsplit('port') }}"
{% endif %}
        - name: LDAP_ROLE_FIELD
          value: {{ greenlight_ldap_role_field }}
        - name: LDAP_SERVER
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
{% endif %}
        - name: LDAP_UID
          value: uid
{% else %}
          value: ""
        - name: LDAP_BASE
          value: ""
        - name: LDAP_BIND_DN
          value: ""
        - name: LDAP_FILTER
          value: ""
        - name: LDAP_METHOD
          value: ""
        - name: LDAP_PASSWORD
          value: ""
        - name: LDAP_PORT
          value: ""
        - name: LDAP_ROLE_FIELD
          value: ""
        - name: LDAP_SERVER
          value: ""
        - name: LDAP_UID
          value: ""
{% endif %}
        - name: MAINTENANCE_MODE
          value: "false"
        - name: MAINTENANCE_WINDOW
          value: ""
        - name: NUMBER_OF_ROWS
          value: "{{ greenlight_rows_count }}"
        - name: PAGINATION_NUMBER
          value: "{{ greenlight_pagination_count }}"
        - name: PORT
          value: "8080"
        - name: RAILS_LOG_TO_STDOUT
          value: "true"
        - name: RELATIVE_URL_ROOT
          value: /b
        - name: ROOM_FEATURES
          value: {{ greenlight_room_features | join(',') }}
        - name: SAFE_HOSTS
          value: {{ greenlight_fqdn }}
        - name: SAML_COMMONNAME_ATTRIBUTE
{% if do_lemon %}
          value: uid
        - name: SAML_EMAIL_ATTRIBUTE
          value: mail
        - name: SAML_IDP_CERT_FINGERPRINT
          valueFrom:
            secretKeyRef:
              key: fingerprint-sha1
              name: {{ lemon_name }}-saml
        - name: SAML_IDP_URL
          value: {{ lemon_portal }}/saml/singleSignOn
        - name: SAML_ISSUER
          value: greenlight
        - name: SAML_NAME_IDENTIFIER
          value: urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress
        - name: SAML_UID_ATTRIBUTE
          value: uid
        - name: SAML_USERNAME_ATTRIBUTE
          value: uid
{% else %}
          value: ""
        - name: SAML_EMAIL_ATTRIBUTE
          value: ""
        - name: SAML_IDP_CERT_FINGERPRINT
          value: ""
        - name: SAML_IDP_URL
          value: ""
        - name: SAML_ISSUER
          value: ""
        - name: SAML_NAME_IDENTIFIER
          value: ""
        - name: SAML_UID_ATTRIBUTE
          value: ""
        - name: SAML_USERNAME_ATTRIBUTE
          value: ""
{% endif %}
        - name: SECRET_KEY_BASE
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ greenlight_name }}
        - name: SMTP_PORT
{% if smtp_relay | default(False) %}
          value: "{{ smtp_port | default('25') }}"
        - name: SMTP_SENDER
          value: {{ greenlight_mail_from | default('greenlight@' ~ root_domain) }}
        - name: SMTP_SERVER
          value: {{ smtp_relay }}
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: none
        - name: SMTP_TLS
          value: ""
{% elif smtps_address | default(False) %}
          value: "{{ smtps_address | urlsplit('port') }}"
        - name: SMTP_SENDER
          value: {{ greenlight_mail_from | default('greenlight@' ~ root_domain) }}
        - name: SMTP_SERVER
          value: {{ smtps_address | urlsplit('hostname') }}
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: peer
        - name: SMTP_TLS
          value: "true"
{% elif smtp_address | default(False) %}
          value: "{{ smtp_address | urlsplit('port') }}"
        - name: SMTP_SENDER
          value: {{ greenlight_mail_from | default('greenlight@' ~ root_domain) }}
        - name: SMTP_SERVER
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: none
        - name: SMTP_TLS
          value: ""
{% else %}
          value: ""
        - name: SMTP_SENDER
          value: ""
        - name: SMTP_SERVER
          value: ""
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: none
        - name: SMTP_TLS
          value: ""
{% endif %}
        - name: SMTP_STARTTLS_AUTO
          value: "false"
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='greenlight'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='greenlight'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 29
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 8080
          timeoutSeconds: 15
        name: greenlight
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            httpHeaders:
            - name: Host
              value: {{ greenlight_fqdn }}
            - name: X-Forwarded-Proto
              value: https
            path: /b/
            port: 8080
            scheme: HTTP
        resources:
          limits:
            cpu: "{{ greenlight_cpu_limit }}"
            memory: "{{ greenlight_memory_limit }}"
          requests:
            cpu: "{{ greenlight_cpu_request }}"
            memory: "{{ greenlight_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 29
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 8080
{% endif %}
        volumeMounts:
        - mountPath: /.cache
          name: temp
          subPath: yarncache
        - mountPath: /usr/local/share/ca-certificates
          name: pkiconf
        - mountPath: /usr/src/app/public/assets
          name: temp
          subPath: assets
{% if greenlight_db_type != 'postgres' %}
        - mountPath: /usr/src/app/db/production
          name: data
          subPath: db
{% endif %}
        - mountPath: /usr/src/app/node_modules
          name: temp
          subPath: modules
        - mountPath: /usr/src/app/storage
{% if greenlight_db_type != 'postgres' %}
          name: data
{% else %}
          name: temp
{% endif %}
          subPath: data
        - mountPath: /usr/src/app/tmp
          name: temp
          subPath: tmp
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
      securityContext:
        runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ greenlight_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
{% if greenlight_db_type != 'postgres' %}
      - name: data
        persistentVolumeClaim:
          claimName: {{ greenlight_name }}
{% endif %}
{% if (k8s_flavor == 'kubernetes' and (smtps_address | default(False) or scalelite_api_public | default(False) or do_ldap)) or (bigbluebutton_ca_bundle | default([])) | length > 0 %}
      - name: pkiconf
        projected:
          sources:
{% if k8s_flavor == 'kubernetes' and do_ldap %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if k8s_flavor == 'kubernetes' and smtps_address | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: smtp-ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if k8s_flavor == 'kubernetes' and scalelite_api_public | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: scalelite-ca.crt
{% if scalelite_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if (bigbluebutton_ca_bundle | default([])) | length > 0 %}
{% for cert in bigbluebutton_ca_bundle %}
          - configMap:
              items:
              - key: bigbluebutton-chain{{ loop.index0 }}.crt
                path: bigbluebutton-chain{{ loop.index0 }}.crt
              name: {{ greenlight_name }}
{% endfor %}
{% endif %}
{% else %}
      - emptyDir: {}
        name: pkiconf
{% endif %}
      - emptyDir: {}
        name: temp
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='greenlight'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - greenlight
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='greenlight'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
